{
  description = "Doggo flake";

  inputs = {
    fenix = {
      url = "github:nix-community/fenix";
      inputs.nixpkgs.follows = "nixpkgs";
    };
    nixpkgs.url = "nixpkgs/nixos-unstable";
  };

  outputs = { self, fenix, nixpkgs }:
    let pkgs = nixpkgs.legacyPackages.x86_64-linux;
    in {
      devShell.x86_64-linux = with pkgs;
        mkShell {
          nativeBuildInputs = [
            just
            pkg-config
            protobuf
            (fenix.packages.x86_64-linux.fromToolchainFile {
              dir = ./.;
              sha256 = "sha256-3St/9/UKo/6lz2Kfq2VmlzHyufduALpiIKaaKX4Pq0g=";
            })
          ];

          buildInputs = [
            curl
            fontconfig
            freetype
            libgit2
            openssl
            sqlite
            zlib
            zstd
            vulkan-loader
          ] ++ lib.optionals stdenv.isLinux [
            alsa-lib
            libxkbcommon
            wayland
            xorg.libxcb
          ];

          env = {
            WAYLAND_DISPLAY = ""; # Window has nor decoration on Wayland
            LD_LIBRARY_PATH = with pkgs; lib.makeLibraryPath [ vulkan-loader ];
          };
        };

      formatter.x86_64-linux = nixpkgs.legacyPackages.x86_64-linux.nixfmt;
    };
}
